# In this document you will learn to create vectors and matrices, and 
# to obtain information from the data

# Notice the use of four hashtags to create titles that can be selected from the bottom drop-down menu. 


# VECTORS ####

# Note, we will provide each vector with a name.
# This process is referred as Creating an object, for example:

# Create an object named wind_speed with values 13 and 17
# I can also say:
# Create an vector named wind_speed with values 13 and 17

wind_speed = c(13, 17)

# This can also refer to single value objects
# Create an object named temperature with value 3

temperature = 3

# LET'S START ####

# Poker and roulette winnings from Monday to Friday
# Create vectors named poker_vector to enter the following data: 
# 140, -50, 20, -120, 240

poker_vector = c(140, -50, 20, -120, 240)

# Notice that the - symbol indicates loosing days
# After creating the new vector, present it by entering its name only below the code you used to create it.
# New objects (vectors in this case) are now displayed on the Environment windows
# All codes outcomes are observed in the Console window

poker_vector

# Create a vector named roulette_vector containing the following values:
# -24, -50, 100, -350, 10

roulette_vector = c(-24, -50, 100, -350, 10)
roulette_vector

# Create a vector named days_vector containing the following values:
# "Monday", "Tuesday", "Wednesday", "Thursday", "Friday"

days_vector = c("Monday", "Tuesday", "Wednesday", "Thursday", "Friday")
days_vector

# Observe how the poker and roulette vectors are presented in the Console
# Only values are observed, there is no connection to days of the week

# Link the days of the week with the values on the poker vector 

names(poker_vector) = days_vector

# Present the poker vector again and see the difference 
# Now the days are link to the values

poker_vector

# Which days did you make money on poker?
# Notice the use of > symbol. Higher than zero because positive values are profits.
# On the list presented on the console, observe which days contain TRUE.

poker_vector  > 0


# Provide a name to the code you created
poker_winnings = poker_vector  > 0
poker_winnings

# Select and present only the wining days
poker_vector[poker_winnings]

# Provide a name
poker_winning_days = poker_vector[poker_winnings]
poker_winning_days

# Present how much money you make on all those days
# Use code sum()
sum(poker_winning_days)


# Which days did you make money on the roulette? and how much?
# Before you see the codes below, try to solved it yourself.
# Start  by linking the days of the week with the values on the roulette vector

# Try first



# Link the days of the week with the values on the roulette vector 
names(roulette_vector) = days_vector

roulette_vector

# Which days did you make money on the roulette? and how much?
roulette_vector > 0

# Provide a name
poker_winnings = roulette_vector > 0
poker_winnings

# Select from roulette_vector these days
roulette_winning_days = roulette_vector[poker_winnings]
roulette_winning_days
sum(roulette_winning_days)



# MATRIX ####

# Create the following three vectors
# The first value corresponds to US market, the second value to non-US market
# Do not worry about the markets yet, we will use them below.

new_hope = c(460.998, 314.4)

empire_strikes = c(290.475, 247.932)

return_jedi = c(309.106, 165.8)


# Create a new vector containing the three vectors you created above.
# Imagine that, a vector containing other vectors
# Name this object box_office

box_office = c(new_hope, empire_strikes, return_jedi)

# Present the object box_office and observe how it looks on the Console
# It appears as a long sequence of six numbers. 

box_office


# Transform the vector box_office into a matrix named star_wars_matrix
# Since box_office contains 3 vectors, make sure the matrix contains 3 rows

star_wars_matrix = matrix(box_office, nrow = 3, byrow = TRUE)

# Present the star_wars_matrix and observe it on the Console
# What is the biggest difference now?

star_wars_matrix


# COLUMN AND ROW NAMES ####


# Create vectors containing the information for the sales region

region = c("US", "non-US")

# Create a vector to enter the actual names of the movies

titles = c("A New Hope", "The Empire Strikes Back", "Return of the Jedi")


# Use the region vector to name the columns of our matrix

colnames(star_wars_matrix) = region

# Present the star_wars_matrix and observe it on the Console
# Now the columns have names, not the row
# Let's name the rows


# Use the titles vector to name the rows of our matrix


# Present the star_wars_matrix and observe it on the Console
# Now the columns and rows have names, cool, isn't?

star_wars_matrix

# How much money each movie made on all markets?
# Create an object named worldwide_vector to save the results



worldwide_vector = rowSums(star_wars_matrix)

worldwide_vector


# ADD A NEW COLUMN ####
#Adding A new value as a new calculated column
# cbind() function merges matrices and/or vectors together by column

# Remember that we have our original matrix named star_wars_matrix
# We also created a calculation to sum the total sames in all markets, this was
# done by creating worldwide_vector

# Add the worldwide_vector as an additional column to star_wars_matrix

all_wars_matrix = cbind(star_wars_matrix, worldwide_vector)

# Present the all_wars_matrix and observe it on the Console
# It now contains three columns

all_wars_matrix


# ADD A NEW ROW ####

# Adding a row uses rbind() function
#Let's create a new matrix star_wars_matrix2 containing 2 additional movies

phantom_menace = c(474.5, 552.5)

attack_clones = c(310.7, 338.7)

# Create a matrix for these two movies
# Notice how they are entered directly using the vector code c() 

star_wars_matrix2 = matrix(c(phantom_menace, attack_clones), nrow = 2, byrow = TRUE)

titles2 <- c("The Phantom Menace", "Attack of the clones")
rownames(star_wars_matrix2) <- titles2

star_wars_matrix2

##Add the new rows to our previous matrix

all_movies = rbind(star_wars_matrix, star_wars_matrix2)

# Present the new data set all_movies and observe it on the Console

all_movies



# FAITHFUL DESCRIPTIVE AND TABLE ####

# Codes to create a table with basic descriptive statistics. 
# Notice that I create but I do not call any of the codes because on the report, 
# I want to present the codes but not their outcomes. 
# Important: be aware of byrow = TRUE/FALSE, make sure you select the correct one.

view(faithful)

mwt = round(mean(faithful$waiting), digits = 2)
sdwt = round(sd(faithful$waiting), digits = 2)
medwt = round(median(faithful$waiting), digits = 2)

mer = round(mean(faithful$eruptions), digits = 2)
sder = round(sd(faithful$eruptions), digits = 2)
meder = round(median(faithful$eruptions), digits = 2)


faithtable1 = c(mwt, sdwt, medwt)
faithtable2 = c(mer, sder, meder)
faithtable3 = matrix(c(faithtable1,faithtable2), nrow = 3, byrow = FALSE)

row_names = c("Mean", "StDev", "Median")
col_names = c("Wating", "Eruption")

colnames(faithtable3) = col_names
rownames(faithtable3) = row_names

faithtable3

dotchart(faithtable3)





# ADDITIONAL CODES ####


# The total box office revenue for the entire saga

total_revenue = colSums(all_movies)
total_revenue

# Selection of matrix elements using [ ]
# use comma to indicate row and column
# Pay attention to each outcome in the console

all_movies[1,1]
all_movies[1:2, 1:2]
all_movies[1,]
all_movies[,1]

# Select the non-US revenue for all movies

non_us_all = all_movies[,2]

non_us_all

# Average non-US revenue

mean(non_us_all)

# Select the non-US revenue for first two movies

non_us_some = all_movies[1:2,2]

# Average non-US revenue for first two movies

mean(non_us_some)


# If price of tickets were $5, estimate the visitors
visitors <- round(all_movies/5, digits = 0)

# Print the estimate to the console
visitors
